// D import file generated from 'derelict/sdl2/image.d'
module derelict.sdl2.image;
private 
{
	import derelict.util.loader;
	import derelict.util.exception;
	import derelict.util.system;
	import derelict.sdl2.types;
	import derelict.sdl2.functions;
	static if (Derelict_OS_Windows)
	{
		enum libNames = "SDL2_image.dll";
	}
	else
	{
		static if (Derelict_OS_Mac)
		{
			enum libNames = "/usr/local/lib/libSDL2_image.dylib, ../Frameworks/SDL2_image.framework/SDL2_image, /Library/Frameworks/SDL2_image.framework/SDL2_image, /System/Library/Frameworks/SDL2_image.framework/SDL2_image";
		}
		else
		{
			static if (Derelict_OS_Posix)
			{
				enum libNames = "libSDL2_image.so, libSDL2_image-2.0.so, libSDL2_image-2.0.so.0, /usr/local/lib/libSDL2_image.so, /usr/local/lib/libSDL2_image-2.0.so, /usr/local/lib/libSDL2_image-2.0.so.0";
			}
			else
			{
				static assert(0, "Need to implement SDL2_image libNames for this operating system.");
			}
		}
	}
}
alias SDL_SetError IMG_SetError;
alias SDL_GetError IMG_GetError;
enum : Uint8
{
	SDL_IMAGE_MAJOR_VERSION = 2,
	SDL_IMAGE_MINOR_VERSION = 0,
	SDL_IMAGE_PATCHLEVEL = 0,
}
nothrow @nogc void SDL_IMAGE_VERSION(SDL_version* X);
enum 
{
	IMG_INIT_JPG = 1,
	IMG_INIT_PNG = 2,
	IMG_INIT_TIF = 4,
	IMG_INIT_WEBP = 8,
}
extern (C) nothrow @nogc 
{
	alias int function(int) da_IMG_Init;
	alias int function() da_IMG_Quit;
	alias const(SDL_version)* function() da_IMG_Linked_Version;
	alias SDL_Surface* function(SDL_RWops*, int, const(char)*) da_IMG_LoadTyped_RW;
	alias SDL_Surface* function(const(char)*) da_IMG_Load;
	alias SDL_Surface* function(SDL_RWops*, int) da_IMG_Load_RW;
	alias SDL_Texture* function(SDL_Renderer*, const(char)*) da_IMG_LoadTexture;
	alias SDL_Texture* function(SDL_Renderer*, SDL_RWops*, int) da_IMG_LoadTexture_RW;
	alias SDL_Texture* function(SDL_Renderer*, SDL_RWops*, int, const(char)*) da_IMG_LoadTextureTyped_RW;
	alias int function(SDL_RWops*) da_IMG_isICO;
	alias int function(SDL_RWops*) da_IMG_isCUR;
	alias int function(SDL_RWops*) da_IMG_isBMP;
	alias int function(SDL_RWops*) da_IMG_isGIF;
	alias int function(SDL_RWops*) da_IMG_isJPG;
	alias int function(SDL_RWops*) da_IMG_isLBM;
	alias int function(SDL_RWops*) da_IMG_isPCX;
	alias int function(SDL_RWops*) da_IMG_isPNG;
	alias int function(SDL_RWops*) da_IMG_isPNM;
	alias int function(SDL_RWops*) da_IMG_isTIF;
	alias int function(SDL_RWops*) da_IMG_isXCF;
	alias int function(SDL_RWops*) da_IMG_isXPM;
	alias int function(SDL_RWops*) da_IMG_isXV;
	alias int function(SDL_RWops*) da_IMG_isWEBP;
	alias SDL_Surface* function(SDL_RWops*) da_IMG_LoadICO_RW;
	alias SDL_Surface* function(SDL_RWops*) da_IMG_LoadCUR_RW;
	alias SDL_Surface* function(SDL_RWops*) da_IMG_LoadBMP_RW;
	alias SDL_Surface* function(SDL_RWops*) da_IMG_LoadGIF_RW;
	alias SDL_Surface* function(SDL_RWops*) da_IMG_LoadJPG_RW;
	alias SDL_Surface* function(SDL_RWops*) da_IMG_LoadLBM_RW;
	alias SDL_Surface* function(SDL_RWops*) da_IMG_LoadPCX_RW;
	alias SDL_Surface* function(SDL_RWops*) da_IMG_LoadPNG_RW;
	alias SDL_Surface* function(SDL_RWops*) da_IMG_LoadPNM_RW;
	alias SDL_Surface* function(SDL_RWops*) da_IMG_LoadTGA_RW;
	alias SDL_Surface* function(SDL_RWops*) da_IMG_LoadTIF_RW;
	alias SDL_Surface* function(SDL_RWops*) da_IMG_LoadXCF_RW;
	alias SDL_Surface* function(SDL_RWops*) da_IMG_LoadXPM_RW;
	alias SDL_Surface* function(SDL_RWops*) da_IMG_LoadXV_RW;
	alias SDL_Surface* function(SDL_RWops*) da_IMG_LoadWEBP_RW;
	alias SDL_Surface* function(char**) da_IMG_ReadXPMFromArray;
	alias int function(SDL_Surface*, const(char)*) da_IMG_SavePNG;
	alias int function(SDL_Surface*, SDL_RWops*, int) da_IMG_SavePNG_RW;
}

__gshared 
{
	da_IMG_Init IMG_Init;
	da_IMG_Quit IMG_Quit;
	da_IMG_Linked_Version IMG_Linked_Version;
	da_IMG_LoadTyped_RW IMG_LoadTyped_RW;
	da_IMG_Load IMG_Load;
	da_IMG_Load_RW IMG_Load_RW;
	da_IMG_LoadTexture IMG_LoadTexture;
	da_IMG_LoadTexture_RW IMG_LoadTexture_RW;
	da_IMG_LoadTextureTyped_RW IMG_LoadTextureTyped_RW;
	da_IMG_isICO IMG_isICO;
	da_IMG_isCUR IMG_isCUR;
	da_IMG_isBMP IMG_isBMP;
	da_IMG_isGIF IMG_isGIF;
	da_IMG_isJPG IMG_isJPG;
	da_IMG_isLBM IMG_isLBM;
	da_IMG_isPCX IMG_isPCX;
	da_IMG_isPNG IMG_isPNG;
	da_IMG_isPNM IMG_isPNM;
	da_IMG_isTIF IMG_isTIF;
	da_IMG_isXCF IMG_isXCF;
	da_IMG_isXPM IMG_isXPM;
	da_IMG_isXV IMG_isXV;
	da_IMG_isWEBP IMG_isWEBP;
	da_IMG_LoadICO_RW IMG_LoadICO_RW;
	da_IMG_LoadCUR_RW IMG_LoadCUR_RW;
	da_IMG_LoadBMP_RW IMG_LoadBMP_RW;
	da_IMG_LoadGIF_RW IMG_LoadGIF_RW;
	da_IMG_LoadJPG_RW IMG_LoadJPG_RW;
	da_IMG_LoadLBM_RW IMG_LoadLBM_RW;
	da_IMG_LoadPCX_RW IMG_LoadPCX_RW;
	da_IMG_LoadPNG_RW IMG_LoadPNG_RW;
	da_IMG_LoadPNM_RW IMG_LoadPNM_RW;
	da_IMG_LoadTGA_RW IMG_LoadTGA_RW;
	da_IMG_LoadTIF_RW IMG_LoadTIF_RW;
	da_IMG_LoadXCF_RW IMG_LoadXCF_RW;
	da_IMG_LoadXPM_RW IMG_LoadXPM_RW;
	da_IMG_LoadXV_RW IMG_LoadXV_RW;
	da_IMG_LoadWEBP_RW IMG_LoadWEBP_RW;
	da_IMG_ReadXPMFromArray IMG_ReadXPMFromArray;
	da_IMG_SavePNG IMG_SavePNG;
	da_IMG_SavePNG_RW IMG_SavePNG_RW;
}
class DerelictSDL2ImageLoader : SharedLibLoader
{
	public this();

	protected override void loadSymbols();

}
__gshared DerelictSDL2ImageLoader DerelictSDL2Image;

shared static this();
