// D import file generated from 'derelict/sdl2/net.d'
module derelict.sdl2.net;
private 
{
	import derelict.util.loader;
	import derelict.util.system;
	import derelict.sdl2.types;
	import derelict.sdl2.functions;
	static if (Derelict_OS_Windows)
	{
		enum libNames = "SDL2_net.dll";
	}
	else
	{
		static if (Derelict_OS_Mac)
		{
			enum libNames = "/usr/local/lib/libSDL2_net.dylib, ../Frameworks/SDL2_net.framework/SDL2_net, /Library/Frameworks/SDL2_net.framework/SDL2_net, /System/Library/Frameworks/SDL2_net.framework/SDL2_net";
		}
		else
		{
			static if (Derelict_OS_Posix)
			{
				enum libNames = "libSDL2_net.so, libSDL2_net-2.0.so, libSDL2_net-2.0.so.0, /usr/local/lib/libSDL2_net-2.0.so, /usr/local/lib/libSDL2_net-2.0.so.0";
			}
			else
			{
				static assert(0, "Need to implement SDL2_net libNames for this operating system.");
			}
		}
	}
}
alias SDL_version SDLNet_Version;
enum : Uint8
{
	SDL_NET_MAJOR_VERSION = 2,
	SDL_NET_MINOR_VERSION = 0,
	SDL_NET_PATCHLEVEL = 0,
}
nothrow @nogc void SDL_NET_VERSION(SDL_version* X);
struct IPaddress
{
	Uint32 host;
	Uint16 port;
}
enum 
{
	INADDR_ANY = 0,
	INADDR_NONE = 4294967295u,
	INADDR_LOOPBACK = 2130706433,
	INADDR_BROADCAST = 4294967295u,
}
alias void* TCPsocket;
enum SDLNET_MAX_UDPCHANNELS = 32;
enum SDLNET_MAX_UDPADRESSES = 4;
alias void* UDPsocket;
struct UDPpacket
{
	int channel;
	Uint8* data;
	int len;
	int maxlen;
	int status;
	IPaddress address;
}
struct _SDLNet_SocketSet;
alias _SDLNet_SocketSet* SDLNet_SocketSet;
struct _SDLNet_GenericSocket
{
	int ready;
}
alias _SDLNet_GenericSocket* SDLNet_GenericSocket;
nothrow @nogc 
{
	int SDLNet_TCP_AddSocket(SDLNet_SocketSet set, void* sock);
	alias SDLNet_TCP_AddSocket SDLNet_UDP_AddSocket;
	int SDLNet_TCP_DelSocket(SDLNet_SocketSet set, void* sock);
	alias SDLNet_TCP_DelSocket SDLNet_UDP_DelSocket;
	bool SDLNet_SocketReady(void* sock);
}
extern (C) nothrow @nogc 
{
	alias const(SDLNet_Version)* function() da_SDLNet_Linked_Version;
	alias int function() da_SDLNet_Init;
	alias void function() da_SDLNet_Quit;
	alias int function(IPaddress*, const(char)*, Uint16) da_SDLNet_ResolveHost;
	alias const(char)* function(const(IPaddress)*) da_SDLNet_ResolveIP;
	alias int function(IPaddress*, int) da_SDLNet_GetLocalAddresses;
	alias TCPsocket function(IPaddress*) da_SDLNet_TCP_Open;
	alias TCPsocket function(TCPsocket) da_SDLNet_TCP_Accept;
	alias IPaddress* function(TCPsocket) da_SDLNet_TCP_GetPeerAddress;
	alias int function(TCPsocket, const(void)*, int) da_SDLNet_TCP_Send;
	alias int function(TCPsocket, void*, int) da_SDLNet_TCP_Recv;
	alias void function(TCPsocket) da_SDLNet_TCP_Close;
	alias UDPpacket* function(int) da_SDLNet_AllocPacket;
	alias int function(UDPpacket*, int) da_SDLNet_ResizePacket;
	alias void function(UDPpacket*) da_SDLNet_FreePacket;
	alias UDPpacket** function(int, int) da_SDLNet_AllocPacketV;
	alias void function(UDPpacket**) da_SDLNet_FreePacketV;
	alias UDPsocket function(Uint16) da_SDLNet_UDP_Open;
	alias void function(UDPsocket, int) da_SDLNet_UDP_SetPacketLoss;
	alias int function(UDPsocket, int, const(IPaddress)*) da_SDLNet_UDP_Bind;
	alias void function(UDPsocket, int) da_SDLNet_UDP_Unbind;
	alias IPaddress* function(UDPsocket, int) da_SDLNet_UDP_GetPeerAddress;
	alias int function(UDPsocket, UDPpacket**, int) da_SDLNet_UDP_SendV;
	alias int function(UDPsocket, int, UDPpacket*) da_SDLNet_UDP_Send;
	alias int function(UDPsocket, UDPpacket**) da_SDLNet_UDP_RecvV;
	alias int function(UDPsocket, UDPpacket*) da_SDLNet_UDP_Recv;
	alias void function(UDPsocket) da_SDLNet_UDP_Close;
	alias SDLNet_SocketSet function(int) da_SDLNet_AllocSocketSet;
	alias int function(SDLNet_SocketSet, SDLNet_GenericSocket) da_SDLNet_AddSocket;
	alias int function(SDLNet_SocketSet, SDLNet_GenericSocket) da_SDLNet_DelSocket;
	alias int function(SDLNet_SocketSet, Uint32) da_SDLNet_CheckSockets;
	alias void function(SDLNet_SocketSet) da_SDLNet_FreeSocketSet;
	alias void function(const(char)* fmt, ...) da_SDLNet_SetError;
	alias const(char)* function() da_SDLNet_GetError;
}

__gshared 
{
	da_SDLNet_Linked_Version SDLNet_Linked_Version;
	da_SDLNet_Init SDLNet_Init;
	da_SDLNet_Quit SDLNet_Quit;
	da_SDLNet_ResolveHost SDLNet_ResolveHost;
	da_SDLNet_ResolveIP SDLNet_ResolveIP;
	da_SDLNet_GetLocalAddresses SDLNet_GetLocalAddresses;
	da_SDLNet_TCP_Open SDLNet_TCP_Open;
	da_SDLNet_TCP_Accept SDLNet_TCP_Accept;
	da_SDLNet_TCP_GetPeerAddress SDLNet_TCP_GetPeerAddress;
	da_SDLNet_TCP_Send SDLNet_TCP_Send;
	da_SDLNet_TCP_Recv SDLNet_TCP_Recv;
	da_SDLNet_TCP_Close SDLNet_TCP_Close;
	da_SDLNet_AllocPacket SDLNet_AllocPacket;
	da_SDLNet_ResizePacket SDLNet_ResizePacket;
	da_SDLNet_FreePacket SDLNet_FreePacket;
	da_SDLNet_AllocPacketV SDLNet_AllocPacketV;
	da_SDLNet_FreePacketV SDLNet_FreePacketV;
	da_SDLNet_UDP_Open SDLNet_UDP_Open;
	da_SDLNet_UDP_SetPacketLoss SDLNet_UDP_SetPacketLoss;
	da_SDLNet_UDP_Bind SDLNet_UDP_Bind;
	da_SDLNet_UDP_Unbind SDLNet_UDP_Unbind;
	da_SDLNet_UDP_GetPeerAddress SDLNet_UDP_GetPeerAddress;
	da_SDLNet_UDP_SendV SDLNet_UDP_SendV;
	da_SDLNet_UDP_Send SDLNet_UDP_Send;
	da_SDLNet_UDP_RecvV SDLNet_UDP_RecvV;
	da_SDLNet_UDP_Recv SDLNet_UDP_Recv;
	da_SDLNet_UDP_Close SDLNet_UDP_Close;
	da_SDLNet_AllocSocketSet SDLNet_AllocSocketSet;
	da_SDLNet_AddSocket SDLNet_AddSocket;
	da_SDLNet_DelSocket SDLNet_DelSocket;
	da_SDLNet_CheckSockets SDLNet_CheckSockets;
	da_SDLNet_FreeSocketSet SDLNet_FreeSocketSet;
	da_SDLNet_SetError SDLNet_SetError;
	da_SDLNet_GetError SDLNet_GetError;
}
class DerelictSDL2NetLoader : SharedLibLoader
{
	public this();

	protected override void loadSymbols();

}
__gshared DerelictSDL2NetLoader DerelictSDL2Net;

shared static this();
