// D import file generated from 'derelict/sdl2/ttf.d'
module derelict.sdl2.ttf;
private 
{
	import core.stdc.config;
	import derelict.util.loader;
	import derelict.util.system;
	import derelict.sdl2.types;
	import derelict.sdl2.functions;
	static if (Derelict_OS_Windows)
	{
		enum libNames = "SDL2_ttf.dll";
	}
	else
	{
		static if (Derelict_OS_Mac)
		{
			enum libNames = "/usr/local/lib/libSDL2_ttf.dylib, ../Frameworks/SDL2_ttf.framework/SDL2_ttf, /Library/Frameworks/SDL2_ttf.framework/SDL2_ttf, /System/Library/Frameworks/SDL2_ttf.framework/SDL2_ttf";
		}
		else
		{
			static if (Derelict_OS_Posix)
			{
				enum libNames = "libSDL2_ttf.so, libSDL2_ttf-2.0.so, libSDL2_ttf-2.0.so.0, /usr/local/lib/libSDL2_ttf-2.0.so, /usr/local/lib/libSDL2_ttf-2.0.so.0";
			}
			else
			{
				static assert(0, "Need to implement SDL2_ttf libNames for this operating system.");
			}
		}
	}
}
enum : Uint8
{
	SDL_TTF_MAJOR_VERSION = 2,
	SDL_TTF_MINOR_VERSION = 0,
	SDL_TTF_PATCHLEVEL = 12,
}
alias SDL_TTF_MAJOR_VERSION TTF_MAJOR_VERSION;
alias SDL_TTF_MINOR_VERSION TTF_MINOR_VERSION;
alias SDL_TTF_PATCHLEVEL TTF_PATCHLEVEL;
enum 
{
	UNICODE_BOM_NATIVE = 65279,
	UNICODE_BOM_SWAPPED = 65534,
	TTF_STYLE_NORMAL = 0,
	TTF_STYLE_BOLD = 1,
	TTF_STYLE_ITALIC = 2,
	TTF_STYLE_UNDERLINE = 4,
	TTF_STYLE_STRIKETHROUGH = 8,
}
enum 
{
	TTF_HINTING_NORMAL = 0,
	TTF_HINTING_LIGHT = 1,
	TTF_HINTING_MONO = 2,
	TTF_HINTING_NONE = 3,
}
alias SDL_SetError TTF_SetError;
alias SDL_GetError TTF_GetError;
struct TTF_Font;
nothrow @nogc 
{
	void SDL_TTF_VERSION(SDL_version* X);
	void TTF_VERSION(SDL_version* X);
}
extern (C) nothrow @nogc 
{
	alias SDL_version* function() da_TTF_Linked_Version;
	alias void function(int) da_TTF_ByteSwappedUNICODE;
	alias int function() da_TTF_Init;
	alias TTF_Font* function(const(char)*, int) da_TTF_OpenFont;
	alias TTF_Font* function(const(char)*, int, c_long) da_TTF_OpenFontIndex;
	alias TTF_Font* function(SDL_RWops*, int, int) da_TTF_OpenFontRW;
	alias TTF_Font* function(SDL_RWops*, int, int, c_long) da_TTF_OpenFontIndexRW;
	alias int function(const(TTF_Font)*) da_TTF_GetFontStyle;
	alias void function(const(TTF_Font)*, int style) da_TTF_SetFontStyle;
	alias int function(const(TTF_Font)*) da_TTF_GetFontOutline;
	alias void function(TTF_Font*, int) da_TTF_SetFontOutline;
	alias int function(const(TTF_Font)*) da_TTF_GetFontHinting;
	alias void function(TTF_Font*, int) da_TTF_SetFontHinting;
	alias int function(const(TTF_Font)*) da_TTF_FontHeight;
	alias int function(const(TTF_Font)*) da_TTF_FontAscent;
	alias int function(const(TTF_Font)*) da_TTF_FontDescent;
	alias int function(const(TTF_Font)*) da_TTF_FontLineSkip;
	alias int function(const(TTF_Font)*) da_TTF_GetFontKerning;
	alias void function(TTF_Font*, int) da_TTF_SetFontKerning;
	alias int function(const(TTF_Font)*) da_TTF_FontFaces;
	alias int function(const(TTF_Font)*) da_TTF_FontFaceIsFixedWidth;
	alias char* function(const(TTF_Font)*) da_TTF_FontFaceFamilyName;
	alias char* function(const(TTF_Font)*) da_TTF_FontFaceStyleName;
	alias int function(const(TTF_Font)*, Uint16) da_TTF_GlyphIsProvided;
	alias int function(TTF_Font*, Uint16, int*, int*, int*, int*, int*) da_TTF_GlyphMetrics;
	alias int function(TTF_Font*, const(char)*, int*, int*) da_TTF_SizeText;
	alias int function(TTF_Font*, const(char)*, int*, int*) da_TTF_SizeUTF8;
	alias int function(TTF_Font*, Uint16*, int*, int*) da_TTF_SizeUNICODE;
	alias SDL_Surface* function(TTF_Font*, const(char)*, SDL_Color) da_TTF_RenderText_Solid;
	alias SDL_Surface* function(TTF_Font*, const(char)*, SDL_Color) da_TTF_RenderUTF8_Solid;
	alias SDL_Surface* function(TTF_Font*, const(Uint16)*, SDL_Color) da_TTF_RenderUNICODE_Solid;
	alias SDL_Surface* function(TTF_Font*, Uint16, SDL_Color) da_TTF_RenderGlyph_Solid;
	alias SDL_Surface* function(TTF_Font*, const(char)*, SDL_Color, SDL_Color) da_TTF_RenderText_Shaded;
	alias SDL_Surface* function(TTF_Font*, const(char)*, SDL_Color, SDL_Color) da_TTF_RenderUTF8_Shaded;
	alias SDL_Surface* function(TTF_Font*, const(Uint16)*, SDL_Color, SDL_Color) da_TTF_RenderUNICODE_Shaded;
	alias SDL_Surface* function(TTF_Font*, Uint16, SDL_Color, SDL_Color) da_TTF_RenderGlyph_Shaded;
	alias SDL_Surface* function(TTF_Font*, const(char)*, SDL_Color) da_TTF_RenderText_Blended;
	alias SDL_Surface* function(TTF_Font*, const(char)*, SDL_Color) da_TTF_RenderUTF8_Blended;
	alias SDL_Surface* function(TTF_Font*, const(Uint16)*, SDL_Color) da_TTF_RenderUNICODE_Blended;
	alias SDL_Surface* function(TTF_Font*, const(char)*, SDL_Color, Uint32) da_TTF_RenderText_Blended_Wrapped;
	alias SDL_Surface* function(TTF_Font*, const(char)*, SDL_Color, Uint32) da_TTF_RenderUTF8_Blended_Wrapped;
	alias SDL_Surface* function(TTF_Font*, const(Uint16)*, SDL_Color, Uint32) da_TTF_RenderUNICODE_Blended_Wrapped;
	alias SDL_Surface* function(TTF_Font*, Uint16, SDL_Color) da_TTF_RenderGlyph_Blended;
	alias void function(TTF_Font*) da_TTF_CloseFont;
	alias void function() da_TTF_Quit;
	alias int function() da_TTF_WasInit;
	alias int function(TTF_Font*, int, int) da_TTF_GetFontKerningSize;
}

__gshared 
{
	da_TTF_Linked_Version TTF_Linked_Version;
	da_TTF_ByteSwappedUNICODE TTF_ByteSwappedUNICODE;
	da_TTF_Init TTF_Init;
	da_TTF_OpenFont TTF_OpenFont;
	da_TTF_OpenFontIndex TTF_OpenFontIndex;
	da_TTF_OpenFontRW TTF_OpenFontRW;
	da_TTF_OpenFontIndexRW TTF_OpenFontIndexRW;
	da_TTF_GetFontStyle TTF_GetFontStyle;
	da_TTF_SetFontStyle TTF_SetFontStyle;
	da_TTF_GetFontOutline TTF_GetFontOutline;
	da_TTF_SetFontOutline TTF_SetFontOutline;
	da_TTF_GetFontHinting TTF_GetFontHinting;
	da_TTF_SetFontHinting TTF_SetFontHinting;
	da_TTF_FontHeight TTF_FontHeight;
	da_TTF_FontAscent TTF_FontAscent;
	da_TTF_FontDescent TTF_FontDescent;
	da_TTF_FontLineSkip TTF_FontLineSkip;
	da_TTF_GetFontKerning TTF_GetFontKerning;
	da_TTF_SetFontKerning TTF_SetFontKerning;
	da_TTF_FontFaces TTF_FontFaces;
	da_TTF_FontFaceIsFixedWidth TTF_FontFaceIsFixedWidth;
	da_TTF_FontFaceFamilyName TTF_FontFaceFamilyName;
	da_TTF_FontFaceStyleName TTF_FontFaceStyleName;
	da_TTF_GlyphIsProvided TTF_GlyphIsProvided;
	da_TTF_GlyphMetrics TTF_GlyphMetrics;
	da_TTF_SizeText TTF_SizeText;
	da_TTF_SizeUTF8 TTF_SizeUTF8;
	da_TTF_SizeUNICODE TTF_SizeUNICODE;
	da_TTF_RenderText_Solid TTF_RenderText_Solid;
	da_TTF_RenderUTF8_Solid TTF_RenderUTF8_Solid;
	da_TTF_RenderUNICODE_Solid TTF_RenderUNICODE_Solid;
	da_TTF_RenderGlyph_Solid TTF_RenderGlyph_Solid;
	da_TTF_RenderText_Shaded TTF_RenderText_Shaded;
	da_TTF_RenderUTF8_Shaded TTF_RenderUTF8_Shaded;
	da_TTF_RenderUNICODE_Shaded TTF_RenderUNICODE_Shaded;
	da_TTF_RenderGlyph_Shaded TTF_RenderGlyph_Shaded;
	da_TTF_RenderText_Blended TTF_RenderText_Blended;
	da_TTF_RenderUTF8_Blended TTF_RenderUTF8_Blended;
	da_TTF_RenderUNICODE_Blended TTF_RenderUNICODE_Blended;
	da_TTF_RenderText_Blended_Wrapped TTF_RenderText_Blended_Wrapped;
	da_TTF_RenderUTF8_Blended_Wrapped TTF_RenderUTF8_Blended_Wrapped;
	da_TTF_RenderUNICODE_Blended_Wrapped TTF_RenderUNICODE_Blended_Wrapped;
	da_TTF_RenderGlyph_Blended TTF_RenderGlyph_Blended;
	da_TTF_CloseFont TTF_CloseFont;
	da_TTF_Quit TTF_Quit;
	da_TTF_WasInit TTF_WasInit;
	da_TTF_GetFontKerningSize TTF_GetFontKerningSize;
}
alias TTF_RenderText_Shaded TTF_RenderText;
alias TTF_RenderUTF8_Shaded TTF_RenderUTF8;
alias TTF_RenderUNICODE_Shaded TTF_RenderUNICODE;
class DerelictSDL2ttfLoader : SharedLibLoader
{
	public this();

	protected override void loadSymbols();

}
__gshared DerelictSDL2ttfLoader DerelictSDL2ttf;

shared static this();
